package net.t2code.alias.Spigot.config.alias;

import com.google.common.base.Preconditions;
import net.t2code.alias.Spigot.Main;
import net.t2code.alias.Spigot.system.AliasRegister;
import net.t2code.alias.Spigot.objects.AliasObject;
import net.t2code.alias.Spigot.system.BukkitCommandWrap_Useless;
import net.t2code.alias.Util;
import net.t2code.t2codelib.SPIGOT.api.messages.T2Csend;
import net.t2code.t2codelib.SPIGOT.api.messages.T2Ctemplate;
import org.bukkit.Bukkit;
import org.bukkit.configuration.InvalidConfigurationException;
import org.bukkit.configuration.file.YamlConfiguration;
import org.bukkit.entity.Player;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.util.List;
import java.util.logging.Level;

public class SelectAlias {
    private static String Prefix = Util.getPrefix();

    public static void onSelect() {

        Main.aliasHashMap.clear();
        Main.allAliases.clear();

        File f = new File(Main.getPath() + "/Alias/");
        File[] fileArray = f.listFiles();
        for (File config_gui : fileArray) {
            if (config_gui.getName().equals("X_aliasDeclaration_X.yml")) continue;

            String sub = config_gui.getName().substring(config_gui.getName().length() - 4);
            if (sub.equals(".yml")) {
                YamlConfiguration yamlConfiguration;
                try {
                    Preconditions.checkArgument(config_gui != null, "File cannot be null");
                    YamlConfiguration config = new YamlConfiguration();
                    config.load(config_gui);
                    yamlConfiguration = config;
                } catch (FileNotFoundException var3) {
                    continue;
                } catch (IOException var4) {
                    Bukkit.getLogger().log(Level.SEVERE, "Cannot load " + config_gui, var4);
                    continue;
                } catch (InvalidConfigurationException var5) {
                    Bukkit.getLogger().log(Level.SEVERE, "Cannot load " + config_gui, var5);
                    continue;
                }
                Boolean aliasEnable = yamlConfiguration.getBoolean("Alias.Enable");
                List<String> aliasList;
                if (yamlConfiguration.get("Alias.AliasList") == null) {
                    AliasConfigConverter.convertAliasList(yamlConfiguration, config_gui);
                }
                aliasList = yamlConfiguration.getStringList("Alias.AliasList");
                Boolean permNecessary = yamlConfiguration.getBoolean("Alias.Permission.Necessary");
                if (yamlConfiguration.get("Alias.Permission.Permission") == null) {
                    AliasConfigConverter.convertAddPermission(yamlConfiguration, config_gui, false);
                }
                String permission = yamlConfiguration.getString("Alias.Permission.Permission");
                if (yamlConfiguration.get("Alias.Permission.CustomNoPermissionMSG") == null) {
                    AliasConfigConverter.convertAddPermissionMSG(yamlConfiguration, config_gui, false);
                }
                String permissionMSG = yamlConfiguration.getString("Alias.Permission.CustomNoPermissionMSG");

                Boolean costEnable = yamlConfiguration.getBoolean("Alias.Cost.Enable");
                Double costPrice = yamlConfiguration.getDouble("Alias.Cost.Price");
                Boolean costAllowBypass = yamlConfiguration.getBoolean("Alias.Cost.AllowByPass");

                Boolean commandEnable = yamlConfiguration.getBoolean("Alias.Command.Enable");
                Boolean commandAsConsole = yamlConfiguration.getBoolean("Alias.Command.CommandAsConsole");
                Boolean bungeeCommand = yamlConfiguration.getBoolean("Alias.Command.BungeeCommand");
                List<String> command = yamlConfiguration.getStringList("Alias.Command.Commands");

                Boolean messageEnable = yamlConfiguration.getBoolean("Alias.Message.Enable");
                List<String> messages = yamlConfiguration.getStringList("Alias.Message.Messages");

                Boolean adminEnable = yamlConfiguration.getBoolean("Alias.Admin.Enable");
                String adminPermission = yamlConfiguration.getString("Alias.Admin.Permission");

                Boolean adminCommandEnable = yamlConfiguration.getBoolean("Alias.Admin.Command.Enable");
                Boolean adminCommandAsConsole = yamlConfiguration.getBoolean("Alias.Admin.Command.CommandAsConsole");
                Boolean adminBungeeCommand = yamlConfiguration.getBoolean("Alias.Admin.Command.BungeeCommand");
                List<String> adminCommands = yamlConfiguration.getStringList("Alias.Admin.Command.Commands");

                Boolean adminMessageEnable = yamlConfiguration.getBoolean("Alias.Admin.Message.Enable");
                List<String> adminMessages = yamlConfiguration.getStringList("Alias.Admin.Message.Messages");

                Boolean consoleEnable = yamlConfiguration.getBoolean("Alias.Console.Enable");
                Boolean consoleCommandEnable = yamlConfiguration.getBoolean("Alias.Console.Command.Enable");
                Boolean consoleBungeeCommand = yamlConfiguration.getBoolean("Alias.Console.Command.BungeeCommand");
                List<String> consoleCommands = yamlConfiguration.getStringList("Alias.Console.Command.Commands");
                Boolean consoleMessageEnable = yamlConfiguration.getBoolean("Alias.Console.Message.Enable");
                List<String> consoleMessages = yamlConfiguration.getStringList("Alias.Console.Message.Messages");

                Main.allAliases.addAll(aliasList);
                AliasObject alias = new AliasObject(aliasEnable, aliasList, permNecessary, permission, permissionMSG, costEnable, costPrice, costAllowBypass, commandEnable, commandAsConsole, bungeeCommand,
                        command, messageEnable, messages, adminEnable, adminPermission, adminCommandEnable, adminCommandAsConsole, adminBungeeCommand, adminCommands,
                        adminMessageEnable, adminMessages, consoleEnable, consoleCommandEnable, consoleBungeeCommand, consoleCommands, consoleMessageEnable, consoleMessages);
                for (String al : aliasList) {
                    Main.aliasHashMap.put(al, alias);
                }
                T2Csend.console(Prefix + " §aAlias file §e" + config_gui.getName() + " §awas loaded");
            }
        }
        T2Ctemplate.onLoadSeparateStroke(Util.getPrefix());
        AliasRegister.onRegister();
    }

    private YamlConfiguration loadFile(File file) throws InvalidConfigurationException {
        return YamlConfiguration.loadConfiguration(file);
    }
}
