package net.t2code.alias.Spigot.config.subAlias;

import net.t2code.alias.Spigot.Main;
import net.t2code.alias.Util;
import net.t2code.t2codelib.SPIGOT.api.messages.T2Csend;
import net.t2code.t2codelib.SPIGOT.api.yaml.T2Cconfig;
import org.bukkit.configuration.file.YamlConfiguration;

import java.io.File;
import java.io.IOException;
import java.util.Arrays;
import java.util.Collections;

public class CreateExampleSubAliasConfig {

    public static void configCreate() {
        long long_ = System.currentTimeMillis();
        T2Csend.console(Util.getPrefix() + " §4SubAlias/aliasexample.yml are created...");

        File config = new File(Main.getPath(), "SubAlias/aliasexample.yml");
        YamlConfiguration yamlConfiguration = YamlConfiguration.loadConfiguration(config);

        T2Cconfig.set("SubAlias.Enable", true, yamlConfiguration);
        T2Cconfig.set("SubAlias.SubAliasList", Arrays.asList("test"), yamlConfiguration);
        T2Cconfig.set("SubAlias.SubAliasFor", "aliasexample1", yamlConfiguration);

        T2Cconfig.set("SubAlias.Permission.Necessary", true, yamlConfiguration);
        T2Cconfig.set("SubAlias.Permission.Permission", "t2code.alias.use.subalias.<alias>", yamlConfiguration);
        T2Cconfig.set("SubAlias.Permission.CustomNoPermissionMSG", "", yamlConfiguration);

        T2Cconfig.set("SubAlias.Cost.Enable", false, yamlConfiguration);
        T2Cconfig.set("SubAlias.Cost.Price", 0.0, yamlConfiguration);
        T2Cconfig.set("SubAlias.Cost.AllowByPass", true, yamlConfiguration);

        T2Cconfig.set("SubAlias.Command.Enable", true, yamlConfiguration);
        T2Cconfig.set("SubAlias.Command.CommandAsConsole", true, yamlConfiguration);
        T2Cconfig.set("SubAlias.Command.BungeeCommand", false, yamlConfiguration);
        T2Cconfig.set("SubAlias.Command.Commands", Arrays.asList("say hi"), yamlConfiguration);

        T2Cconfig.set("SubAlias.Message.Enable", false, yamlConfiguration);
        T2Cconfig.set("SubAlias.Message.Messages",Arrays.asList(), yamlConfiguration);

        T2Cconfig.set("SubAlias.Admin.Enable", false, yamlConfiguration);
        T2Cconfig.set("SubAlias.Admin.Permission", "t2code.alias.admin", yamlConfiguration);

        T2Cconfig.set("SubAlias.Admin.Command.Enable", true, yamlConfiguration);
        T2Cconfig.set("SubAlias.Admin.Command.CommandAsConsole", true, yamlConfiguration);
        T2Cconfig.set("SubAlias.Admin.Command.BungeeCommand", false, yamlConfiguration);
        T2Cconfig.set("SubAlias.Admin.Command.Commands", Arrays.asList("say subalias hi"), yamlConfiguration);

        T2Cconfig.set("SubAlias.Admin.Message.Enable", false, yamlConfiguration);
        T2Cconfig.set("SubAlias.Admin.Message.Messages",Arrays.asList(), yamlConfiguration);

        T2Cconfig.set("SubAlias.Console.Enable", false, yamlConfiguration);
        T2Cconfig.set("SubAlias.Console.Command.Enable", false, yamlConfiguration);
        T2Cconfig.set("SubAlias.Console.Command.BungeeCommand", false, yamlConfiguration);
        T2Cconfig.set("SubAlias.Console.Command.Commands",Arrays.asList(), yamlConfiguration);
        T2Cconfig.set("SubAlias.Console.Message.Enable", false, yamlConfiguration);
        T2Cconfig.set("SubAlias.Console.Message.Messages",Arrays.asList(), yamlConfiguration);
        try {
            yamlConfiguration.save(config);
        } catch (IOException e) {
            e.printStackTrace();
        }
        T2Csend.console(Util.getPrefix() + " §2Alias/aliasexample.yml were successfully created." + " §7- §e" + (System.currentTimeMillis() - long_) + "ms");
    }
}
